/*
             Extra Buttons AddIn for POIDE
                  by L. D. Blake 2012
*/

#include "global.h"

HANDLE hInst    = NULL; // dll instance handle
HWND   hProject = NULL; // project window handle
HWND   hSource  = NULL; // source window handle
BOOL   PrjAdded = FALSE;
BOOL   SrcAdded = FALSE;

///////////////////////////////////////////////////////////////////////////////
// Button commands

// open project folder
void OpenProjectFolder(void)
  { TCHAR cwd[MAX_PATH];
    GetCurrentDirectory(MAX_PATH,cwd);
    ShellExecute(NULL,L"OPEN",cwd,NULL,NULL,SW_SHOWNORMAL); }

// open command shell
void OpenCommandShell(void)
  { TCHAR cwd[MAX_PATH];
    GetCurrentDirectory(MAX_PATH,cwd);
    ShellExecute(NULL,L"OPEN",L"CMD.EXE",cwd,NULL,SW_SHOWNORMAL); }
  
//open task manager
void OpenTaskManager(void)
  { ShellExecute(NULL,L"OPEN",L"TASKMGR.EXE",NULL,NULL,SW_SHOWNORMAL); }



// button command tosser
ADDINAPI void WINAPI AddInCommandEx(INT Cmd, LPCVOID Data)
  { switch (Cmd)
      { case 101 :
          AddIn_SendIDECommand(hSource,AIC_PROJ_REBUILD);
          return;
        case 102 :
          AddIn_SendIDECommand(hSource,AIC_PROJ_REBUILDWKS);
          return;
        case 103 :
          OpenProjectFolder();
          return;      
        case 104 :
          OpenCommandShell();
          return;
        case 105 :
          OpenTaskManager();
          return;
        case 106 :
          AddIn_SendIDECommand(hSource,AIC_EDIT_FIND);
          return;  
        case 107 :
          AddIn_SendIDECommand(hSource,AIC_EDIT_REPLACE);
          return;
        case 108 :
          AddIn_SendIDECommand(hSource,AIC_EDIT_FILEFIND);
          return;
        case 109 :
          AddIn_SendIDECommand(hSource,AIC_WIN_CASCADE);
          return;
        case 110 :
          AddIn_SendIDECommand(hSource,AIC_WIN_TILEVERT);
          return;
        case 111 :
          AddIn_SendIDECommand(hSource,AIC_WIN_TILEHORZ);
          return;
        case 112 :
          AddIn_SendIDECommand(hSource,AIC_WIN_CLOSEALL);
          return;
        case 113 :
          AddIn_SendIDECommand(hSource,AIC_PROJ_ADDPROJECT);
          return;
        case 114 :
          AddIn_SendIDECommand(hSource,AIC_PROJ_SETACTIVE);
          return;
        case 115 :
          AddIn_SendIDECommand(hSource,AIC_PROJ_ADDFILE);
          return;
        case 116 :
          AddIn_SendIDECommand(hSource,AIC_PROJ_SETTINGS);
          return;
        case 117 :
          AddIn_SendIDECommand(hSource,AIC_PROJ_DEPENDENCIES);
          return;
        case 118 :
          AddIn_SendIDECommand(hSource,AIC_PROJ_MAKEALLPREQS);
          return;
        default :
          return; } }  



///////////////////////////////////////////////////////////////////////////////
// IDE->AddIn Events 
//

// add commands to main toolbar
BOOL AddToSource (HWND hWin)
  { ADDIN_ADD_COMMAND ac;
    TCHAR rst[65]= {0};
    DWORD bit = 1;
    if (SrcAdded)
      return TRUE;
    // precondition struct
    ac.cbSize = sizeof(ac);
    ac.idMenu = AIM_MENU_NOTHING;
    // individual Buttons
    for (int x = 1; x < 13; x++)
      { if(Setup & bit)
          { LoadString(hInst,10000 + x,rst,64);
            ac.pszText= rst;
            ac.hIcon  = LoadImage(hInst,MAKEINTRESOURCE(8000 + x),IMAGE_ICON,
                                  16,16,LR_LOADTRANSPARENT);
            ac.id     = x + 100;
            if (! AddIn_AddCommand(hWin,&ac))
              Beep(1000,100) ; } 
        bit <<= 1; }
    SrcAdded = TRUE;
    return TRUE; }

// remove from main toolbar
BOOL RemoveFromSource(HWND hWin)
  { for (int x = 1; x < 13; x++)
      AddIn_RemoveCommand(hWin,x + 100);
    SrcAdded = FALSE;
    return TRUE; }



// add commands to project toolbar
BOOL AddToProject (HWND hWin)
  { TCHAR path[MAX_PATH]; 
    ADDIN_ADD_COMMAND ac;
    TCHAR rst[65]= {0};
    DWORD bit = 0x1000;
    if (PrjAdded)
      return TRUE;
    // set working directory
    if ( AddIn_GetProjectSymbol(hWin,L"POC_PROJECT_RESULTDIR",path,MAX_PATH) > 0)
      SetCurrentDirectory(path);
    // precondition struct
    ac.cbSize = sizeof(ac);
    ac.idMenu = AIM_MENU_NOTHING;
    // individual Buttons
    for (int x = 13; x < 19; x++)
      { if(Setup & bit)
          { LoadString(hInst,10000 + x,rst,64);
            ac.pszText= rst;
            ac.hIcon  = LoadImage(hInst,MAKEINTRESOURCE(8000 + x),IMAGE_ICON,
                                  16,16,LR_LOADTRANSPARENT);
            ac.id     = x + 100;
            if (! AddIn_AddCommand(hWin,&ac))
              Beep(1000,100) ; } 
        bit <<= 1; }
    PrjAdded = TRUE;
    return TRUE; }

// remove from main toolbar
BOOL RemoveFromProject(HWND hWin)
  { for (int x = 13; x < 19; x++)
      AddIn_RemoveCommand(hWin,x + 100);
    PrjAdded = FALSE;
    return TRUE; }



// call back from IDE
ADDINAPI BOOL WINAPI AddInMain(HWND hWin,ADDIN_EVENT Evt)
  { switch (Evt)
      { case AIE_APP_CREATE :
          hSource = hWin;
          if (! LoadSettings())
            ShowSettings(hWin);
          return AddToSource(hWin);
        case AIE_APP_DESTROY :
          return RemoveFromSource(hWin);
        case AIE_PRJ_CREATE :
          hProject = hWin;
          return AddToProject(hWin);
        case AIE_PRJ_DESTROY :
          return RemoveFromProject(hWin);
        default :
          return TRUE; } }
        

///////////////////////////////////////////////////////////////////////////////
// settings dialog
//

ADDINAPI void WINAPI AddInSetup(HWND hWin,LPCVOID Data)
  { RemoveFromSource(hSource);
    RemoveFromProject(hProject);
    ShowSettings(hWin);
    AddToSource(hSource); 
    if (hProject != NULL);
      AddToProject(hProject); }


///////////////////////////////////////////////////////////////////////////////
// Dll attach point
//
BOOL WINAPI DllMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved)
  { switch (dwReason)
      { case DLL_PROCESS_ATTACH:
          hInst = hDLL;
          return TRUE;
        case DLL_PROCESS_DETACH:
          return TRUE;
        default:
          return TRUE; } }









