/*

 File    : OpenCmd.c
 Purpose : Add-Inmodule for PellesC.
 
Opens a command shell in the project directory

*/
#define UNICODE
#define _UNICODE
#define WIN32_LEAN_AND_MEAN
#define WIN32_DEFAULT_LIBS
#include <windows.h>
#include <shellapi.h>
#include <addin.h>

// Locals.
static HANDLE g_hmod      = NULL;
static HANDLE g_MainWind  = NULL;
static WCHAR g_ProjectPath[MAX_PATH]  = {0};

///////////////////////////////////////////////////////////////////////////////
// Dll attach point
//
BOOL WINAPI DllMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved)
  { switch (dwReason)
      { case DLL_PROCESS_ATTACH:
          g_hmod = hDLL;
          return TRUE;
        case DLL_PROCESS_DETACH:
          return TRUE;
        default:
          return TRUE; } }


////////////////////////////////////////////////////////////////////////////////
// Add in messages
//

void AddIn_AddCmd( HWND win )
  { ADDIN_ADD_COMMAND adc = {0};
    // load up struct
    adc.cbSize  = sizeof(adc);
    adc.id      = 100; 
    adc.pszText = L"Open Command Shell";    
    adc.hIcon   = LoadIcon(g_hmod,L"SHELLICO");
    adc.idMenu  = AIM_MENU_NOTHING;
    // add new icon
    AddIn_AddCommand(win,&adc); 
    // add to project menu 
    adc.id      = 101;
    adc.idMenu  = AIM_MENU_PROJECT;
    AddIn_AddCommand(win,&adc); }



///////////////////////////////////////////////////////////////////////////////
// Add in message tosser
//
ADDINAPI BOOL WINAPI AddInMain(HWND hwnd, ADDIN_EVENT eEvent)
  { switch (eEvent)
      { case AIE_APP_CREATE :   // IDE startup
            g_MainWind = hwnd;   
            AddIn_AddCmd(hwnd);
            AddIn_GetIDEFolder(g_MainWind,ADDIN_FOLDER_BIN,g_ProjectPath,MAX_PATH);
            return TRUE;
        case AIE_APP_DESTROY :  // IDE exit
            AddIn_RemoveCommand(hwnd,100);
            AddIn_RemoveCommand(hwnd,101);
            return TRUE;
        case AIE_PRJ_CREATE:    // open default project
            AddIn_GetProjectSymbol(hwnd,L"POC_PROJECT_RESULTDIR",g_ProjectPath,MAX_PATH);
            return TRUE;
        case AIE_PRJ_DESTROY:   // close default project
            AddIn_GetIDEFolder(g_MainWind,ADDIN_FOLDER_BIN,g_ProjectPath,MAX_PATH);
            return TRUE;
        default:
            return TRUE; } }



///////////////////////////////////////////////////////////////////////////////
// Add In Command callback
//
ADDINAPI void WINAPI AddInCommandEx(int idCmd, LPCVOID pcvData)
  { switch (idCmd)
      { case 100 :
        case 101 :
          ShellExecute(NULL,L"Open",L"cmd.exe",NULL,g_ProjectPath,SW_SHOWNORMAL); } }


