﻿//
//                 OPEN WEB PAGE IN EXTERNAL BROWSER
//               Add in for Pelles C by LD Blake, 2012
//

#define UNICODE  
#define _UNICODE  

#define WIN32_DEFAULT_LIBS
#include <windows.h>
#include <addin.h>

// Locals.
static HANDLE hInst = NULL;
static HWND hMain = NULL;


// menu and button commands from POIDE
ADDINAPI void WINAPI AddInCommandEx(int idCmd, LPCVOID pcvData)
  { 
    HWND mdi = NULL;    // mdi page handle
    ADDIN_WEB_INFO wi;  // web struct

    // only care about one command value
    if (idCmd != 100)
      return;

    // get current page handle
    mdi = AddIn_GetActiveDocument(hMain);
    if (!mdi)
      return;

    // get url info and launch
    wi.cbSize = sizeof(wi);
    if (AddIn_GetWebInfo(mdi,&wi))
      {
        ShellExecute(NULL,L"Open",wi.pszURL,NULL,NULL,SW_SHOWNORMAL);     
        AddIn_CloseDocument(mdi);
      }
  }



// initialize the addin
BOOL InitAddIn(HWND Win)
  { 
    ADDIN_ADD_COMMAND ac = {0};
    hMain = Win;
    ac.cbSize = sizeof(ac);
    ac.hIcon  = LoadImage(hInst,L"AICON",IMAGE_ICON,16,16,LR_LOADTRANSPARENT); 
    ac.pszText= L"Transfer to default browser";
    ac.idMenu = AIM_MENU_WEB;
    ac.id     = 100;
    return AddIn_AddCommand(hMain,&ac); 
  }



// main addin procedure
ADDINAPI BOOL WINAPI AddInMain(HWND hwnd, ADDIN_EVENT eEvent)
  { 
    switch (eEvent)
      { 
        case AIE_APP_CREATE:
            return InitAddIn(hwnd); 
         case AIE_APP_DESTROY :
            return AddIn_RemoveCommand(hwnd,100);
        default:
            return TRUE;  
      } 
  }



// dll main entry point
BOOL WINAPI DllMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved)
  { 
    hInst = hDLL;
    return TRUE;  
  }

