//
//                         QUICK FLAGS
//                 AddIn module for Pelles IDE
//                      By LD Blake, 2011
//
/* 2012-08-20 7:45:52 */

#define WIN32_DEFAULT_LIBS
#define UNICODE  
#define _UNICODE  

#include <windows.h>
#include <addin.h>


// Buffer sizes for various strings
// if you run out of space, adjust these and recompile
// Set MAX_BUFFER to longest of MAX_FLAGS, MAX_INCLUDES, MAX_LIBS

#define MAX_FLAGS     256
#define MAX_INCLUDES  2048
#define MAX_LIBS      1024
#define MAX_BUFFER    MAX_INCLUDES  

// Locals.
HANDLE hMod   = NULL;
HWND hMain    = NULL;
HWND hProj    = NULL;


// read command lines from project
VOID GetCmdLines(HWND Dlg )
  { 
    TCHAR ps[MAX_BUFFER];  // temp string

    AddIn_GetProjectSymbol(hProj,L"CCFLAGS",ps,MAX_FLAGS);
    SetDlgItemText(Dlg,4001,ps);

    AddIn_GetProjectSymbol(hProj,L"ASFLAGS",ps,MAX_FLAGS);
    SetDlgItemText(Dlg,4002,ps); 

    AddIn_GetProjectSymbol(hProj,L"LINKFLAGS",ps,MAX_FLAGS);
    SetDlgItemText(Dlg,4003,ps);

    AddIn_GetProjectSymbol(hProj,L"ARFLAGS",ps,MAX_FLAGS);
    SetDlgItemText(Dlg,4004,ps);

    AddIn_GetProjectSymbol(hProj,L"RCFLAGS",ps,MAX_FLAGS);
    SetDlgItemText(Dlg,4005,ps); 

    AddIn_GetProjectSymbol(hProj,L"SIGNFLAGS",ps,MAX_FLAGS);
    SetDlgItemText(Dlg,4006,ps); 

    AddIn_GetProjectSymbol(hProj,L"INCLUDE",ps,MAX_INCLUDES);
    SetDlgItemText(Dlg,4007,ps); 

    AddIn_GetProjectSymbol(hProj,L"LIB",ps,MAX_LIBS);
    SetDlgItemText(Dlg,4008,ps); 
  }



// save command lines to project
VOID SaveCmdLines(HWND Dlg)
  { 
    TCHAR ps[MAX_BUFFER];
    
    if (SendDlgItemMessage(Dlg,4001,EM_GETMODIFY,0,0))
      { 
        GetDlgItemText(Dlg,4001,ps,MAX_FLAGS);
        AddIn_SetProjectSymbol(hProj,L"CCFLAGS",ps); 
      }

    if (SendDlgItemMessage(Dlg,4002,EM_GETMODIFY,0,0))
      { 
        GetDlgItemText(Dlg,4002,ps,MAX_FLAGS);
        AddIn_SetProjectSymbol(hProj,L"ASFLAGS",ps); 
      }

    if (SendDlgItemMessage(Dlg,4003,EM_GETMODIFY,0,0))
      { 
        GetDlgItemText(Dlg,4003,ps,MAX_FLAGS);
        AddIn_SetProjectSymbol(hProj,L"LINKFLAGS",ps); 
      }

    if (SendDlgItemMessage(Dlg,4004,EM_GETMODIFY,0,0))
      { 
        GetDlgItemText(Dlg,4004,ps,MAX_FLAGS);
        AddIn_SetProjectSymbol(hProj,L"ARFLAGS",ps); 
      }

    if (SendDlgItemMessage(Dlg,4005,EM_GETMODIFY,0,0))
      { 
        GetDlgItemText(Dlg,4005,ps,MAX_FLAGS);
        AddIn_SetProjectSymbol(hProj,L"RCFLAGS",ps); 
      } 

    if (SendDlgItemMessage(Dlg,4006,EM_GETMODIFY,0,0))
      { 
        GetDlgItemText(Dlg,4006,ps,MAX_FLAGS);
        AddIn_SetProjectSymbol(hProj,L"SIGNFLAGS",ps); 
      }

    if (SendDlgItemMessage(Dlg,4007,EM_GETMODIFY,0,0))
      { 
        GetDlgItemText(Dlg,4007,ps,MAX_INCLUDES);
        AddIn_SetProjectSymbol(hProj,L"INCLUDE",ps);
      } 

   if (SendDlgItemMessage(Dlg,4008,EM_GETMODIFY,0,0))
      { 
        GetDlgItemText(Dlg,4008,ps,MAX_LIBS);
        AddIn_SetProjectSymbol(hProj,L"LIB",ps); 
      }
  }



// dialog window message tosser
BOOL CALLBACK QFTosser(HWND Dlg, UINT Msg, WPARAM wParm, LPARAM lParm)
  { 
    switch (Msg)
      { 
        case WM_INITDIALOG :
          GetCmdLines(Dlg);
          return TRUE;
        case WM_COMMAND :
          switch (LOWORD(wParm))
            { 
              case IDCANCEL :
                EndDialog(Dlg, 0);
                return TRUE;
              case IDOK :
                SaveCmdLines(Dlg);
                EndDialog(Dlg, 0);
                return TRUE; 
            } 
      }
    return FALSE; 
  }  



// menu and button commands from POIDE
ADDINAPI void WINAPI AddInCommandEx(int idCmd, LPCVOID pcvData)
  { 
    if (idCmd == 1000 || idCmd == 1001)
      DialogBox(hMod,L"QFLAGS",hMain,(DLGPROC) &QFTosser); 
  }



// add to project bar
BOOL AddToProjectBar(HWND hwnd)
  { 
    ADDIN_ADD_COMMAND ac = {0};

    if (hProj)
      return TRUE;

    hProj = hwnd;
    ac.cbSize = sizeof(ac);
    ac.hIcon  = LoadImage(hMod,L"QFLAGS",IMAGE_ICON,16,16,LR_LOADTRANSPARENT); 
    ac.pszText= L"Quick set build options";
    ac.idMenu = AIM_MENU_NOTHING;
    ac.id     = 1000;
    AddIn_AddCommand(hwnd,&ac);

    ac.idMenu = AIM_MENU_PROJECT;
    ac.id     = 1001;
    AddIn_AddCommand(hwnd,&ac); 
    return TRUE; 
  }



// take down the button
BOOL RemoveFromProjectBar(HWND hwnd)
  { 
    hProj = NULL;
    AddIn_RemoveCommand(hwnd,1000);
    AddIn_RemoveCommand(hwnd,1001);
    return TRUE; 
  }



// main addin procedure
ADDINAPI BOOL WINAPI AddInMain(HWND hwnd, ADDIN_EVENT eEvent)
  { 
    switch (eEvent)
      { 
        case AIE_APP_CREATE :
          hMain = hwnd;
          return TRUE;
        case AIE_PRJ_CREATE :
          return AddToProjectBar(hwnd);
        case AIE_PRJ_DESTROY :
          return RemoveFromProjectBar(hwnd);
        default:
          return TRUE;  
      } 
  }



// dll entry point
BOOL WINAPI DllMain(HANDLE hDLL, DWORD dwReason, LPVOID lpReserved)
  { 
    switch (dwReason)
      { 
        case DLL_PROCESS_ATTACH:
          hMod = hDLL;
          return TRUE;
        case DLL_PROCESS_DETACH:
          return TRUE;
        default:
          return TRUE;  
      } 
  }


