/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//                 Workspace Manager AddIn for Pelles POIDE                //
//                     Create and edit workspace files                     //
//                                                                         //
//                            By LD Blake, 2012                            //
/////////////////////////////////////////////////////////////////////////////

// global include file

#pragma once

// do not disable unicode!
#define UNICODE  
#define _UNICODE  

#define WIN32_DEFAULT_LIBS
#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <commdlg.h>
#include <shellapi.h>
#include <shlwapi.h>
#include <shlobj.h>
#include <addin.h>
#include <wchar.h>


#define REG_SETUP L"Software\\Pelle Orinius\\PellesC\\WorkspaceManager"
#define REG_HIVE  HKEY_CURRENT_USER

#define MAX_PPJ   8192  // maximum size of PPJ file
#define MAX_PPW   4096  // maximum size of PPW file
#define MAX_NAME  128   // maximum size of project name  


extern HANDLE hMod;  // DLL instance handle
extern HWND hMain;   // POIDE main window
extern HWND hProj;   // POIDE project window

// get a filename from the user
BOOL GetFileName(HWND Owner, PWCHAR Filter, PWCHAR Result);
// get a pathname from the user
BOOL GetFolderName(HWND Owner,PWCHAR Root, PWCHAR Result);

// get a string from the registry
BOOL RegLoadString(PWCHAR Reg, PWCHAR Result);
// get a dword from the registry
DWORD RegLoadDword(PWCHAR Reg);

// in place conversion of To path  
BOOL MakeRelativePath(PWCHAR To, PWCHAR From);

// write WCHAR string to utf8 file
BOOL DiskWrite(PWCHAR Buffer, PWCHAR Name);

